use super::*;
use btrfs_structs::key;
use btrfs_structs::{Key, ItemType, TreeID};
use btrfs_lookup::Tree;
use memmap2::Mmap;
use std::fs::OpenOptions;

#[test]
fn test_key_new() {
	assert_eq!(
		Key::new(1, ItemType::Root, 2),
		Key { key_id: 1, key_type: ItemType::Root, key_offset: 2 }
	);
}

#[test]
fn image_test() {
	let file = OpenOptions::new().read(true).open("../image").unwrap();
	let image = unsafe { Mmap::map(&file).unwrap() };

	let extent_tree = Tree::new(&image, TreeID::Extent).unwrap();

	let skip = |Key { key_id, key_type, key_offset }| Key { key_id: key_id + 0x10000, key_type, key_offset };

	for item in extent_tree.range_with_skip(Some(key!(0x1d70000)), Some(key!(0x2000000)), skip) {
		println!("{item:x?}");
	}
}
